// CMONOS.JP JavaScript Library cart.js
// Copyright (C) 2009-2017 CMONOS Co. Ltd.

// Last-Mocified:2014-04-03

cmonos.tool.shoppingcart = {

	window : {
		isLegacyIE : ((typeof (document.createElement('div')).style.maxHeight == "undefined") ? true : false),
		type : "iframe",
		top : "top",
		left : -300,
		width : "auto",
		height : "auto",

		open : function (this_form) {
			if (this.type == null || this.type == 'self') {
				return true;
			} else if (this.type == 'new') {
				window.open('','shoppingcart','width=' + ((this.target_width != null) ? this.target_width : 640) + ',height=' + ((this.target_height != null) ? this.target_height : 480) + ',scrollbars=yes,resizable=yes');
				this_form.target = "shoppingcart";
				return true;
			}
			if (document.getElementById('shoppingcart')) {
				if (this.clearing) {
					this.clear();
				} else {
					this_form.target = "shoppingcart";
					return true;
				}
			}
			this.clearing = false;
			var cart_window = this;
			var class_name = '';
			if (this.type == 'modal') {
				this.shoppingcart_layer = document.createElement('div');
				this.shoppingcart_layer.id = 'shoppingcart-layer';
				if (this.isLegacyIE) {
					this.shoppingcart_layer.style.height = (document.documentElement.scrollHeight || document.body.scrollHeight) + 'px';
					this.shoppingcart_layer.style.width = (document.documentElement.scrollWidth || document.body.scrollWidth) + 'px';
				}
				cmonos.element._addEventListener(this.shoppingcart_layer,'click',function () { cart_window.close() },false);
				document.getElementsByTagName('body')[0].appendChild(this.shoppingcart_layer);
				class_name += 'shoppingcart-modal';
			}
			this.shoppingcart = document.createElement('iframe');
			this.shoppingcart.id = 'shoppingcart';
			this.shoppingcart.name = 'shoppingcart';

			if (this.top == 'bottom' || this.top < 0) {
				if (this.isLegacyIE) {
					this.shoppingcart.style.top = (cmonos.window.getPageYOffset() + cmonos.window.getInnerHeight() + 32) + 'px';
				} else {
					this.shoppingcart.style.bottom = '-' + cmonos.window.getInnerHeight() + 'px';
				}
			} else {
				this.shoppingcart.style.top = '-' + cmonos.window.getInnerHeight() + 'px';
			}
			if (this.left == 'right' || this.left < 0) {
				if (this.isLegacyIE) {
					this.shoppingcart.style.left = (cmonos.window.getPageXOffset() + cmonos.window.getInnerWidth() + 32) + 'px';
				} else {
					this.shoppingcart.style.right = '-' + cmonos.window.getInnerHeight() + 'px';
				}
			} else {
				this.shoppingcart.style.left = '-' + cmonos.window.getInnerHeight() + 'px';
			}

			if (this.top == 'top' || this.top == 0) {
				class_name += ((class_name != '') ? ' ' : '') + 'shoppingcart-top';
			} else if (this.top == 'bottom') {
				class_name += ((class_name != '') ? ' ' : '') + 'shoppingcart-bottom';
			}
			if (this.left == 'left' || this.left == 0) {
				class_name += ((class_name != '') ? ' ' : '') + 'shoppingcart-left';
			} else if (this.left == 'right') {
				class_name += ((class_name != '') ? ' ' : '') + 'shoppingcart-right';
			}
			this.shoppingcart.className = class_name;

			this.shoppingcart.style.maxWidth = (cmonos.window.getInnerWidth() - 64) + 'px';
			this.shoppingcart.style.maxHeight = (cmonos.window.getInnerHeight() - 64) + 'px';

			document.getElementsByTagName('body')[0].appendChild(this.shoppingcart);
			this.isTransitionReady = ((
									typeof this.shoppingcart.style.MozTransitionProperty != 'undefined'
								 || typeof this.shoppingcart.style.webkitTransitionProperty != 'undefined'
								 || typeof this.shoppingcart.style.OTransitionProperty != 'undefined'
								 || typeof this.shoppingcart.style.msTransitionProperty != 'undefined'
								 || typeof this.shoppingcart.style.transitionProperty != 'undefined'
								 ) ? true : false);
			cart_window.resetFunc = function () { cart_window.positionReset() };
			cmonos.element._addEventListener(
				cart_window.shoppingcart,
				'load',
				function () {
					cart_window.positionReset(true);
					if (cart_window.isTransitionReady) {
						setTimeout(function () {
							cart_window.shoppingcart.style.MozTransitionProperty = 'top,bottom,left,right,width,height,opacity';
							cart_window.shoppingcart.style.webkitTransitionProperty = 'top,bottom,left,right,width,height,opacity';
							cart_window.shoppingcart.style.OTransitionProperty = 'top,bottom,left,right,width,height,opacity';
							cart_window.shoppingcart.style.msTransitionProperty = 'top,bottom,left,right,width,height,opacity';
							cart_window.shoppingcart.style.transitionProperty = 'top,bottom,left,right,width,height,opacity';
							cart_window.shoppingcart.style.MozTransitionDuration = '0.3s';
							cart_window.shoppingcart.style.webkitTransitionDuration = '0.3s';
							cart_window.shoppingcart.style.OTransitionDuration = '0.3s';
							cart_window.shoppingcart.style.msTransitionDuration = '0.3s';
							cart_window.shoppingcart.style.transitionDuration = '0.3s';
							cart_window.positionReset();
						},100);
					} else {
						cart_window.pull();
					}
					cmonos.element._addEventListener(cart_window.shoppingcart,'load',cart_window.resetFunc,false);
					cmonos.element._removeEventListener(cart_window.shoppingcart,'load',arguments.callee);
				},
				false
			);
			cmonos.element._addEventListener(self,'resize',cart_window.resetFunc,false);
			if (this.isLegacyIE) cmonos.element._addEventListener(self,'scroll',cart_window.resetFunc,false);
			if (this.shoppingcart.contentWindow) this.shoppingcart.contentWindow.name = this.shoppingcart.name;
			this_form.target = this.shoppingcart.name;
			return true;
		},

		setSize : function () {
			var max_width = cmonos.window.getInnerWidth() - 64;
			var max_height = cmonos.window.getInnerHeight() - 64;
			this.shoppingcart.style.maxWidth = max_width + 'px';
			this.shoppingcart.style.maxHeight = max_height + 'px';
			var gap_width = (parseInt(this.shoppingcart.style.width) > 0) ? this.shoppingcart.offsetWidth - parseInt(this.shoppingcart.style.width) : 2;
			if (gap_width < 0) gap_width = 2;
			if (this.width == 'auto') {
				this.shoppingcart.style.width = ((this.left == 'center') ? (max_width > 640) ? 640 : max_width : 226) + 'px';
			} else {
				this.shoppingcart.style.width = ((max_width < this.width) ? max_width : this.width) + 'px';
			}
			this.cart_width = parseInt(this.shoppingcart.style.width) + gap_width;
			var gap_height = (parseInt(this.shoppingcart.style.height) > 0) ? this.shoppingcart.offsetHeight - parseInt(this.shoppingcart.style.height) : 2;
			if (gap_height < 0) gap_height = 2;
			if (this.height == 'auto') {
				this.shoppingcart.style.height = 'auto';
				var cart_document = this.shoppingcart.contentDocument || this.shoppingcart.contentWindow.document;
				var h = cart_document.documentElement.scrollHeight || cart_document.body.scrollHeight;
				this.shoppingcart.style.height = ((max_height < h) ? max_height : h) + 'px';
			} else {
				this.shoppingcart.style.height = ((max_height < this.height) ? max_height : this.height) + 'px';
			}
			this.cart_height = parseInt(this.shoppingcart.style.height) + gap_height;
		},

		positionReset : function (hide) {
			this.setSize();
			this.pos_top = null;
			this.pos_bottom = null;
			this.pos_left = null;
			this.pos_right = null;
			this.hidden_top = null;
			this.hidden_bottom = null;
			this.hidden_left = null;
			this.hidden_right = null;
			var offset_height = this.cart_height || this.shoppingcart.offsetHeight;
			var top = (this.isLegacyIE) ? cmonos.window.getPageYOffset() : 0;
			if (this.top == 'top' || this.top == 0) {
				this.pos_top = top;
			} else if (this.top == 'center') {
				this.pos_top = top + parseInt((cmonos.window.getInnerHeight() - this.cart_height) / 2);
			} else if (this.top == 'bottom') {
				if (this.isLegacyIE) {
					this.pos_top = cmonos.window.getPageYOffset() + cmonos.window.getInnerHeight() - this.cart_height;
				} else {
					this.pos_bottom = 0;
				}
			} else if (this.top > 0) {
				this.pos_top = ((this.isLegacyIE) ? cmonos.window.getPageYOffset() + this.top : this.top);
			} else {
				if (this.isLegacyIE) {
					this.pos_top = cmonos.window.getPageYOffset() + cmonos.window.getInnerHeight() + this.top;
				} else {
					this.pos_bottom = 0 - this.cart_height - this.top;
					if (this.pos_bottom < 0) this.pos_bottom = 0;
				}
			}
			if (this.pos_top != null) {
				this.hidden_top = (this.isLegacyIE && (this.top == 'bottom' || this.top < 0)) ? top + cmonos.window.getInnerHeight() + 32 : (this.top != 'top' && this.top != 'bottom' && this.top != 0 && (this.left == 'left' || this.left == 'right' || this.left == 0)) ? this.pos_top : top - this.cart_height - 32;
			} else if (this.pos_bottom != null) {
				this.hidden_bottom = 0 - this.cart_height - 32;
			}
			var offset_width = this.cart_width || this.shoppingcart.offsetWidth;
			var left = (this.isLegacyIE) ? cmonos.window.getPageXOffset() : 0;
			if (this.left == 'left' || this.left == 0) {
				this.pos_left = left;
			} else if (this.left == 'center') {
				this.pos_left = left + parseInt((cmonos.window.getInnerWidth() - this.cart_width) / 2);
			} else if (this.left == 'right') {
				if (this.isLegacyIE) {
					this.pos_left = cmonos.window.getPageXOffset() + cmonos.window.getInnerWidth() - this.cart_width;
				} else {
					this.pos_right = 0;
				}
			} else if (this.left > 0) {
				this.pos_left = ((this.isLegacyIE) ? cmonos.window.getPageXOffset() + this.left : this.left);
			} else {
				if (this.isLegacyIE) {
					this.pos_left = cmonos.window.getPageXOffset() + cmonos.window.getInnerWidth() + this.left;
				} else {
					this.pos_right = 0 - this.cart_width - this.left;
					if (this.pos_right < 0) this.pos_right = 0;
				}
			}
			if (this.pos_left != null) {
				this.hidden_left = (this.isLegacyIE && this.top == 'right') ? left + cmonos.window.getInnerWidth() + 32 : (this.left == 'left' || this.left == 0) ? left - this.cart_width - 32 : this.pos_left;
			} else if (this.pos_right != null) {
				this.hidden_right = (this.left == 'right') ? 0 - this.cart_width - 32 : this.pos_right;
			}
			if (hide) {
				if (this.hidden_top != null) {
					this.shoppingcart.style.top = this.hidden_top + 'px';
					this.shoppingcart.style.bottom = 'auto';
				} else if (this.hidden_bottom != null) {
					this.shoppingcart.style.top = 'auto';
					this.shoppingcart.style.bottom = this.hidden_bottom + 'px';
				}
				if (this.hidden_left != null) {
					this.shoppingcart.style.left = this.hidden_left + 'px';
					this.shoppingcart.style.right = 'auto';
				} else if (this.hidden_right != null) {
					this.shoppingcart.style.left = 'auto';
					this.shoppingcart.style.right = this.hidden_right + 'px';
				}
			} else {
				if (this.pos_top != null) {
					this.shoppingcart.style.top = this.pos_top + 'px';
					this.shoppingcart.style.bottom = 'auto';
				} else if (this.pos_bottom != null) {
					this.shoppingcart.style.top = 'auto';
					this.shoppingcart.style.bottom = this.pos_bottom + 'px';
				}
				if (this.pos_left != null) {
					this.shoppingcart.style.left = this.pos_left + 'px';
					this.shoppingcart.style.right = 'auto';
				} else if (this.pos_right != null) {
					this.shoppingcart.style.left = 'auto';
					this.shoppingcart.style.right = this.pos_right + 'px';
				}
			}
		},

		pull : function (close) {
			var top = (close) ? this.hidden_top : this.pos_top;
			var bottom = (close) ? this.hidden_bottom : this.pos_bottom;
			var left = (close) ? this.hidden_left : this.pos_left;
			var right = (close) ? this.hidden_right : this.pos_right;
			var cart_window = this;
			this.pull_timer = setInterval(function () {
				var x = parseInt((left != null) ? cart_window.shoppingcart.style.left : cart_window.shoppingcart.style.right);
				var y = parseInt((top != null) ? cart_window.shoppingcart.style.top : cart_window.shoppingcart.style.bottom);
				var target_x = (left != null) ? left : right;
				var target_y = (top != null) ? top : bottom;
				var x_gap = target_x - x;
				var y_gap = target_y - y;
				if (Math.abs(x_gap) < 10 && Math.abs(y_gap) < 10) {
					if (left != null) {
						cart_window.shoppingcart.style.left = target_x + 'px';
					} else {
						cart_window.shoppingcart.style.right = target_x + 'px';
					}
					if (top != null) {
						cart_window.shoppingcart.style.top = target_y + 'px';
					} else {
						cart_window.shoppingcart.style.bottom = target_y + 'px';
					}
					clearInterval(cart_window.pull_timer);
					if (close) cart_window.clear();
				} else {
					x = x + Math.ceil(x_gap / 2);
					if (left != null) {
						cart_window.shoppingcart.style.left = x + 'px';
					} else {
						cart_window.shoppingcart.style.right = x + 'px';
					}
					y = y + Math.ceil(y_gap / 2);
					if (top != null) {
						cart_window.shoppingcart.style.top = y + 'px';
					} else {
						cart_window.shoppingcart.style.bottom = y + 'px';
					}
				}
			},50);
			return this;
		},

		close : function () {
			var cart_window = (this.shoppingcart) ? this : (parent && parent.document.getElementById('shoppingcart')) ? parent.cmonos.tool.shoppingcart.window : null;
			if (cart_window) {
				cart_window.clearing = true;
				if (cart_window.isTransitionReady) {
					cart_window.positionReset(true);
					cart_window.transition_timer = setInterval(function () { cart_window.clear(); },500);
				} else {
					cart_window.positionReset();
					cart_window.pull(true);
				}
			}
		},

		clear : function () {
			if (this.transition_timer) clearTimeout(this.transition_timer);
			if (this.pull_timer) clearTimeout(this.pull_timer);
			if (this.resetFunc) {
				cmonos.element._removeEventListener(self,'resize',this.resetFunc,false);
				if (this.isLegacyIE) cmonos.element._removeEventListener(self,'scroll',this.resetFunc,false);
			}
			if (document.getElementById('shoppingcart-layer')) document.getElementsByTagName('body')[0].removeChild(document.getElementById('shoppingcart-layer'));
			document.getElementsByTagName('body')[0].removeChild(document.getElementById('shoppingcart'));
		},

		sizeCheck : function (min_width,min_height) {
			if (parent && parent != self) return;
			var resize_x = 0;
			var resize_y = 0;
			var inner_width = cmonos.window.getInnerWidth();
			var inner_height = cmonos.window.getInnerHeight();
			if (min_width != null && min_width > inner_width) {
				resize_x = min_width - inner_width;
			}
			if (min_height != null && min_height > inner_height) {
				resize_y = min_height - inner_height;
			}
			if (resize_x > 0 || resize_y > 0) window.resizeBy(resize_x,resize_y);
		}
	},

	alert_required : true,
	recalculate : function () {
		var partial_sum = 0;
		var total_sum = 0;
		var n = 0;
		var discount;
		if (this.data.discount) {
			var total = 0;
			for(var i=0; i<this.data.item.length; i++) {
				if (this.data.item[i].discountable) total += this.data.item[i].price * ((this.data.item[i].quantity_id) ? parseInt(cmonos.form.field(this.data.item[i].quantity_id).getValue()) : this.data.item[i].quantity);
			}
			for(var i=0; i<this.data.discount.length; i++) {
				if (this.data.discount[i].ratio && this.data.discount[i].bound <= total) {
					discount = this.data.discount[i].ratio;
					break;
				}
			}
		}
		for(var i=0; i<this.data.item.length; i++) {
			var this_tr = document.getElementById(this.data.item[i].price_id.replace(/-price$/,""));
			if (this.data.item[i].quantity_id) {
				var quantity = parseInt(cmonos.form.field(this.data.item[i].quantity_id).getValue());
				if (isNaN(quantity) || parseInt(quantity) == 0) {
					quantity = 0;
					cmonos.form.field(this.data.item[i].quantity_id).setValue(quantity);
					if (this_tr != null) this_tr.style.display = "none";
				} else {
					if (this_tr != null) this_tr.className = (n++ % 2) ? "even" : "odd";
				}
				this.data.item[i].quantity = quantity;
			}
			var price = this.data.item[i].price;
			if (discount && this.data.item[i].discountable) {
				price = parseInt(price * (1 - (discount/100)));
				document.getElementById(this.data.item[i].unit_price_id).innerHTML = "<del>&yen;"+cmonos.value.comma(this.data.item[i].price)+"</del><ins>(-"+this.rounddown(discount)+"%)</ins> &yen;"+cmonos.value.comma(price);
			} else {
				document.getElementById(this.data.item[i].unit_price_id).innerHTML = "&yen;"+cmonos.value.comma(price);
			}
			var amount = price * this.data.item[i].quantity;
			partial_sum += amount;
			document.getElementById(this.data.item[i].price_id).innerHTML = "&yen;"+cmonos.value.comma(amount);
		}
		if (this.data.tax_rate != null && this.data.tax_rate > 0) {
			document.getElementById(this.data.sc_sub_total_id).innerHTML = "&yen;"+cmonos.value.comma(partial_sum);
			var tax = partial_sum * this.data.tax_rate;
			tax = (this.data.tax_frac == null || this.data.tax_frac == "ceil") ? Math.ceil(tax) : (this.data.tax_frac == "floor") ? Math.floor(tax) : Math.round(tax);
			partial_sum += tax;
			document.getElementById(this.data.sc_tax_id).innerHTML = "&yen;"+cmonos.value.comma(tax);
		}
		document.getElementById(this.data.sc_total_id).innerHTML = "&yen;"+cmonos.value.comma(partial_sum);
		if (this.alert_required) {
			alert('「再計算」するか「レジに進む」まで、数量の変更は保存されません。');
			this.alert_required = false;
		}
	},

	rounddown : function (n) {
		if (this.data.rounddown && this.data.rounddown > 1) {
			var r = (this.data.rounddown - 1) * 10;
			return Math.floor(n * r) / r;
		}
		return n;
	},

	deleteItem : function (this_trash,item_id) {
		this_trash.className += '-active';
		document.getElementById('quantity:'+item_id).value = "0";
		if (!this.ajaxDisabled) {
			this.alert_required = false;
			this.recalculate();
			cmonos.xml.request(
				document.location.href.replace(/\?.*$/,""), 
				{
					method: 'post', 
					parameters: 'm=HandyCart&cancel='+escape(item_id), 
					onComplete: function(){this_trash.className = this_trash.className.replace(/-active$/,"");}
				}
			);
		} else {
			this.recalculate();
			this_trash.className = this_trash.className.replace(/-active$/,"");
		}
	},

	changeItem : function (item_id,item_quantity) {
		if (isNaN(item_quantity) || item_quantity == 0) document.getElementById('quantity:'+item_id).value = "0";
		if (!this.ajaxDisabled) {
			this.alert_required = false;
			this.recalculate();
			var iframeDisabled = this.iframeDisabled || false;
			var here = document.location.href.replace(/\?.*$/,"");
			cmonos.xml.request(
				here, 
				{
					method: 'post', 
					parameters: 'm=HandyCart&item='+escape(item_id)+'&quantity='+escape(item_quantity),
					onSuccess: function(transport){
						var response_hash = cmonos.value.urlDecode(transport.responseText);
						if (response_hash["message"] != null && response_hash["message"] != "") {
							var msg = response_hash["message"].split(";");
							for (var i=0; i < msg.length; i++) {
								if (msg[i] != "") alert(msg[i]);
							}
						}
						if (response_hash["status"] != null && response_hash["status"] == "error") {
							document.location.href = here + '?m=CartViewer' + ((iframeDisabled) ? '&iframe_disabled=1' : '');
						}
					}
				}
			);
		} else {
			this.recalculate();
		}
	},

	setTarget : function (this_form) {
		if (!window.opener) {
			if (parent.opener && typeof parent.name != "undefined" && parent.name.search(/viewer/i) != -1 && typeof parent.opener.cmonos.tool.shoppingcart != "undefined") {
				if (typeof parent.opener.name == "undefined" || parent.opener.name == "") {
					parent.opener.name = 'window' + (new Date()).getTime();
				}
				setTimeout(function() { cmonos.tool.shoppingcart.window.close(); }, 2000);
				this_form.target = parent.opener.name;
				parent.opener.focus();
				parent.opener.document.focus();
			} else if (parent.document.getElementById('shoppingcart')) {
				this_form.target = '_parent';
			}
		}
		return true;
	}
}